searchNodes=[{"doc":"IP location lookup provider. Usage Fetching information for a single IP is done by passing it as a binary or tuple to Geolix.lookup/1: iex&gt; Geolix.lookup(&quot;127.0.0.1&quot;) %{ city: %{...}, country: %{...} } The response will be a map with the :id of each configured database as the key and the database response as the value. If you are only interested in the response of a specific database you can use Geolix.lookup/2: iex&gt; Geolix.lookup({127, 0, 0, 1}, where: :my_database) %{...} The result structured of each database is specific to the adapter used. Lookup Options There are two options you can pass to Geolix.lookup/2 to modify the lookup behaviour: :timeout - GenServer call timeout for the lookup. Defaults to 5_000. :where - Lookup information in a single registered database The adapter used can require and/or understand additional options. To accommodate this the options are passed unmodified to the adapter&#39;s on lookup function.","ref":"Geolix.html","title":"Geolix","type":"module"},{"doc":"Loads a database according to its specification. Requires at least the fields :id and :adapter. Any other required fields depend on the adapter&#39;s requirements.","ref":"Geolix.html#load_database/1","title":"Geolix.load_database/1","type":"function"},{"doc":"Looks up IP information.","ref":"Geolix.html#lookup/2","title":"Geolix.lookup/2","type":"function"},{"doc":"Fetch metadata from one or multiple databases.","ref":"Geolix.html#metadata/1","title":"Geolix.metadata/1","type":"function"},{"doc":"Reloads all configured databases in the background.","ref":"Geolix.html#reload_databases/0","title":"Geolix.reload_databases/0","type":"function"},{"doc":"Unloads a database. This operation is lazy. The database will stay loaded but won&#39;t be reloaded or used for lookups.","ref":"Geolix.html#unload_database/1","title":"Geolix.unload_database/1","type":"function"},{"doc":"Adapter behaviour module.","ref":"Geolix.Adapter.html","title":"Geolix.Adapter","type":"behaviour"},{"doc":"Returns the children to be supervised by Geolix.Database.Supervisor. If no automatic supervision should take place or it is intended to use an adapter specific supervisor (e.g. using the application config) this callback should be either unimplemented or return an empty list.","ref":"Geolix.Adapter.html#c:database_workers/1","title":"Geolix.Adapter.database_workers/1","type":"callback"},{"doc":"Loads a given database into Geolix. Requires at least the fields :id and :adapter. Any other required fields depend on the adapter&#39;s requirements.","ref":"Geolix.Adapter.html#c:load_database/1","title":"Geolix.Adapter.load_database/1","type":"callback"},{"doc":"Looks up IP information.","ref":"Geolix.Adapter.html#c:lookup/3","title":"Geolix.Adapter.lookup/3","type":"callback"},{"doc":"Returns metadata information for a database if available.","ref":"Geolix.Adapter.html#c:metadata/1","title":"Geolix.Adapter.metadata/1","type":"callback"},{"doc":"Unloads a given database from Geolix.","ref":"Geolix.Adapter.html#c:unload_database/1","title":"Geolix.Adapter.unload_database/1","type":"callback"},{"doc":"Fake adapter for testing environments. Usage This adapter is intended to be used only with static data you can provide when the adapter is started, i.e. when performing unit tests. iex&gt; Geolix.load_database(%{ ...&gt; id: :fake_sample, ...&gt; adapter: Geolix.Adapter.Fake, ...&gt; data: %{ ...&gt; {127, 0, 0, 1} =&gt; &quot;IPv4&quot;, ...&gt; {0, 0, 0, 0, 0, 0, 0, 1} =&gt; &quot;IPv6&quot; ...&gt; } ...&gt; }) :ok iex&gt; Geolix.lookup(&quot;127.0.0.1&quot;, where: :fake_sample) &quot;IPv4&quot; iex&gt; Geolix.lookup(&quot;::1&quot;, where: :fake_sample) &quot;IPv6&quot; iex&gt; Geolix.lookup(&quot;255.255.255.255&quot;, where: :fake_sample) nil The lookup is done by exactly matching the IP address tuple received and will return the predefined result as is. Metadata The adapter provides access to the time the database was loaded: metadata = %{load_epoch: System.os_time(:second)}","ref":"Geolix.Adapter.Fake.html","title":"Geolix.Adapter.Fake","type":"module"},{"doc":"Takes care of (re-) loading databases.","ref":"Geolix.Database.Loader.html","title":"Geolix.Database.Loader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Geolix.Database.Loader.html#child_spec/1","title":"Geolix.Database.Loader.child_spec/1","type":"function"},{"doc":"Returns state information for a specific database","ref":"Geolix.Database.Loader.html#get_database/1","title":"Geolix.Database.Loader.get_database/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Geolix.Database.Loader.html#init/1","title":"Geolix.Database.Loader.init/1","type":"function"},{"doc":"Returns a list of all completely loaded databases.","ref":"Geolix.Database.Loader.html#loaded_databases/0","title":"Geolix.Database.Loader.loaded_databases/0","type":"function"},{"doc":"Returns a list of all registered databases. Registered databases may or may not be already loaded.","ref":"Geolix.Database.Loader.html#registered_databases/0","title":"Geolix.Database.Loader.registered_databases/0","type":"function"},{"doc":"This supervisor module takes care of starting the required database adapter processes. It is automatically started with the :geolix application. If you do not want to automatically start the application itself you can adapt your configuration for a more manual supervision approach. Instead of adding :geolix to your :applications list or using the automatic discovery you need to add it to your :included_applications: def application do [ included_applications: [ # ... :geolix, # ... ] ] end That done you can add Geolix.Supervisor to your hierarchy: children = [ # ... Geolix.Supervisor, # ... ]","ref":"Geolix.Supervisor.html","title":"Geolix.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Geolix.Supervisor.html#child_spec/1","title":"Geolix.Supervisor.child_spec/1","type":"function"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Configuring startup_sync: true allows you to ensure a synchronous database load is done during startup. This may have unwanted consequences when your loading process takes longer than around 5 seconds (default startup timeout), e.g. when loading a database from a remote location Usage of deprecated Supervisor functions has been removed (#30)","ref":"changelog.html#v1-1-0-2020-05-04","title":"Changelog - v1.1.0 (2020-05-04)","type":"extras"},{"doc":"The adapter Geolix.Adapter.MMDB2 has been extracted a separate repository. You should be able to upgrade to the external adapter by changing your project&#39;s dependencies from :geolix to :geolix_adapter_mmdb2 with an appropriate version requirement. Enhancements Database metadata is now available via Geolix.metadata/0,1 (#26) Backwards incompatible changes The database workers function of an adapter will now receive the full database configuration to be configured as the sole parameter The lookup function of an adapter will now receive the full database configuration to be used for the lookup as a third parameter","ref":"changelog.html#v1-0-0-2019-09-08","title":"Changelog - v1.0.0 (2019-09-08)","type":"extras"},{"doc":"Enhancements Initializer modules can be defined with additional arguments by using {mod, fun, args} Backwards incompatible changes Minimum required Elixir version is now ~&gt; 1.5","ref":"changelog.html#v0-18-0-2019-03-17","title":"Changelog - v0.18.0 (2019-03-17)","type":"extras"},{"doc":"Enhancements Storage of the internal database loader state has been migrated to a named ets table in order to allow reading from databases while the loading cycle has not yet been completed (#20). The :is_in_european_union information has been added to the Country and RepresentedCountry result structs Backwards incompatible changes Adapters are now responsible to return the complete (and final) result of the lookup. No additional modifications will be made. Several module namespaces have been renamed for this: Geolix.Model -&gt; Geolix.Adapter.MMDB2.Model Geolix.Record -&gt; Geolix.Adapter.MMDB2.Record Geolix.Result -&gt; Geolix.Adapter.MMDB2.Result","ref":"changelog.html#v0-17-0-2018-09-02","title":"Changelog - v0.17.0 (2018-09-02)","type":"extras"},{"doc":"Enhancements Configuration can be done on supervisor (re-) start by setting a {mod, fun} tuple for the config key :init. This method will be called without arguments Every configured database can define a {mod, fun} tuple for the config key :init. This method, called upon database supervisor (re-) start, receives the current database configuration and is expected to return the full configuration used for starting the individual database Unloading a database now calls unload_database/1 of the unloaded database adapter passing the current configuration and expecting :ok as a result","ref":"changelog.html#v0-16-0-2018-02-21","title":"Changelog - v0.16.0 (2018-02-21)","type":"extras"},{"doc":"Bug fixes The MMDB2 decoding library is now properly included in releases","ref":"changelog.html#v0-15-1-2017-12-04","title":"Changelog - v0.15.1 (2017-12-04)","type":"extras"},{"doc":"Enhancements The MMDB2 file format decoding logic has been extracted to the new :mmdb2_decoder library Backwards incompatible changes Minimum required Elixir version is now ~&gt; 1.3","ref":"changelog.html#v0-15-0-2017-11-25","title":"Changelog - v0.15.0 (2017-11-25)","type":"extras"},{"doc":"Enhancements Configuration errors are logged and/or returned Databases can be unloaded. This is done lazy so while still being in memory it won&#39;t be reloaded or used for lookups Databases in tarball format (.tar or .tar.gz) are now supported (#16) Errors are now always returned in a tuple format ({:error, type}) Errors occurring while initially loading databases (or when calling Geolix.reload_databases/0) are now sent to Logger.error (#16) &quot;GeoLite2-ASN&quot; databases return structs instead of plain maps System environment configuration can set an optional default value to be used if the environment variable is unset When an error occurs during database load the database will be excluded from the lookup process Backwards incompatible changes Previous {:error, String.t} return values have been removed in favor of tuples and Logger.error/1","ref":"changelog.html#v0-14-0-2017-06-20","title":"Changelog - v0.14.0 (2017-06-20)","type":"extras"},{"doc":"Backwards incompatible changes Minimum required Elixir version is now ~&gt; 1.2 Minimum required Erlang version is now ~&gt; 18.0","ref":"changelog.html#v0-13-0-2017-04-12","title":"Changelog - v0.13.0 (2017-04-12)","type":"extras"},{"doc":"Ownership has been transferred to the elixir-geolix organisation Backwards incompatible changes Support for non-map database configuration has been removed Support for GeoIP2-Precision-City and GeoIP2-Precision-Country database files has been removed (matching upstream)","ref":"changelog.html#v0-12-0-2017-03-26","title":"Changelog - v0.12.0 (2017-03-26)","type":"extras"},{"doc":"Enhancements All configured databases can be reloaded in the background using Geolix.reload_databases/0 Database configuration has been extended to support adapters Geolix.Adapter.Fake is provided for a custom managed database with fixed/pre-defined responses GeoIP-Enterprise databases return structs instead of plain maps Lookups are done with a configurable timeout Deprecations Configuring the application&#39;s databases using {:id, filename} tuples (or Keyword.t) has been deprecated in favor of a list of database definition maps Geolix.set_database/2 has been deprecated in favor of the new Geolix.load_database/1","ref":"changelog.html#v0-11-0-2016-12-28","title":"Changelog - v0.11.0 (2016-12-28)","type":"extras"},{"doc":"Enhancements Lookup results are generated with :en as the default if no locale is passed","ref":"changelog.html#v0-10-1-2016-06-04","title":"Changelog - v0.10.1 (2016-06-04)","type":"extras"},{"doc":"Enhancements Databases are reloaded if a storage process gets restarted Databases can be directly loaded from remote (http) locations if configured (#10) Paths can be configured by accessing the system environment Storage processes are now supervised Bug fixes Traits from the database are properly passed on in the result","ref":"changelog.html#v0-10-0-2016-04-04","title":"Changelog - v0.10.0 (2016-04-04)","type":"extras"},{"doc":"Enhancements Allows usage of GeoIP2-Precision-ISP databases Lookups querying all registered databases are done concurrently","ref":"changelog.html#v0-9-0-2015-11-16","title":"Changelog - v0.9.0 (2015-11-16)","type":"extras"},{"doc":"Enhancements Allows direct usage of gzip&#39;ed database files :locale lookup option for easier access to translatable result values Dependencies not used in production builds are marked as optional Bug fixes Float values are rounded to 4 decimal digits Double values are rounded to 8 decimal digits","ref":"changelog.html#v0-8-0-2015-07-18","title":"Changelog - v0.8.0 (2015-07-18)","type":"extras"},{"doc":"Enhancements Supports IPv4 lookups in IPv6 notation (&quot;0:0:0:0:0:FFFF:xxxx:xxxx&quot;) Supports IPv6 lookups","ref":"changelog.html#v0-7-0-2015-02-16","title":"Changelog - v0.7.0 (2015-02-16)","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#v0-6-0-2015-02-08","title":"Changelog - v0.6.0 (2015-02-08)","type":"extras"},{"doc":"Geolix IP location lookup provider. Note: If you are reading this on GitHub then the information in this file may be out of sync with the Hex package. If you are using this library through Hex please refer to the appropriate documentation on HexDocs (link available on Hex).","ref":"readme.html","title":"Geolix","type":"extras"},{"doc":"To use Geolix with your projects, edit your mix.exs file and add the project as a dependency: defp deps do [ # ... {:geolix, &quot;~&gt; 1.0&quot;}, # ... ] end If you want to use a manual supervision approach (without starting the application) please look at the inline documentation of Geolix.Supervisor.","ref":"readme.html#package-setup","title":"Geolix - Package Setup","type":"extras"},{"doc":"To get started you need to define one or more :databases to use for lookups. Each database definition is a map with at least two fields: :id - an identifier for this database, usable to limit lookups to a single database if you have defined more than one :adapter - the adapter module used to handle lookup requests. See the part &quot;Adapters&quot; in this document for additional information Depending on the adapter you may need to provide additional values. Configuration (static) One option for configuration is using a static configuration, i.e. for two databases handled by the adapter MyAdapter: config :geolix, databases: [ %{ id: :city, adapter: MyAdapter, source: &quot;/absolute/path/to/city.db&quot; }, %{ id: :country, adapter: MyAdapter, source: &quot;/absolute/path/to/country.db&quot; } ] Configuration (dynamic) If there are any reasons you cannot use a pre-defined configuration you can also configure an initializer module to be called before starting the top-level suprevisor or alternatively for each individual database. This may be the most suitable configuration if you have the database located in the :priv_dir of your application. # {mod, fun} config :geolix, init: {MyInitModule, :my_init_mf_toplevel} config :geolix, databases: [ %{ id: :dynamic_country, adapter: MyAdapter, init: {MyInitModule, :my_init_mf_database} } ] # {mod, fun, args} config :geolix, init: {MyInitModule, :my_init_mfargs_toplevel, [:foo, :bar]} config :geolix, databases: [ %{ id: :dynamic_country, adapter: MyAdapter, init: {MyInitModule, :my_init_mfargs_database, [:foo, :bar]} } ] # initializer module defmodule MyInitModule do @spec my_init_mf_toplevel() :: :ok def my_init_mf_toplevel(), do: my_init_mfargs_toplevel(:foo, :bar) @spec my_init_mfargs_toplevel(atom, atom) :: :ok def my_init_mfargs_toplevel(:foo, :bar) do priv_dir = Application.app_dir(:my_app, &quot;priv&quot;) databases = [ %{ id: :dynamic_city, adapter: MyAdapter, source: Path.join([priv_dir, &quot;city.db&quot;]) } | Application.get_env(:geolix, :databases, []) ] Application.put_env(:geolix, :databases, databases) end @spec my_init_mf_database(map) :: map def my_init_mf_database(database) do my_init_mfargs_database(database, :foo, :bar) end @spec my_init_mfargs_database(map, atom, atom) :: map def my_init_mfargs_database(%{id: :dynamic_country} = database, :foo, :bar) do priv_dir = Application.app_dir(:my_app, &quot;priv&quot;) %{database | source: Path.join([priv_dir, &quot;country.db&quot;])} end end Above example illustrates both types of dynamic initialization. The top-level initializer is called as defined ({mod, fun} or {mod, fun, args}) and expected to always return :ok. At the database level the current database configuration is passed as the first parameter with optional {m, f, a} parameters following. It is expected that this function return the new, complete configuration. If you choose to use the dynamic database initialization the only requirement for your config file is a plain %{init: {MyInitModule, :my_init_fun}} entry. Every additional field in the example is only used for illustration and only required for the complete return value. Configuration (runtime) If you do not want to use a pre-defined or dynamically initialized configuration you can also define adapters at runtime. This may be useful in a testing environment. iex(1)&gt; Geolix.load_database(%{ ...(1)&gt; id: :runtime_city, ...(1)&gt; adapter: MyAdapter, ...(1)&gt; source: &quot;/absolute/path/to/city.db&quot; ...(1)&gt; }) :ok Please be aware that these databases will not be reloaded if, for any reason, the supervisor/application is restarted. Running load_database/1 on an already configured database (matched by :id) will reload/replace it without persisting the configuration. On success a result of :ok will be returned otherwise a tuple in the style of {:error, message}. The individual errors are defined by the adapter.","ref":"readme.html#application-configuration","title":"Geolix - Application Configuration","type":"extras"},{"doc":"All the work done by geolix is handled using adapters. These adapters can use a database, a webservice or any other means available to handle your lookup requests. Known adapters: Geolix.Adapter.Fake Geolix.Adapter.LookupCache Geolix.Adapter.MMDB2 For detailed information how to configure the adapter of your choice please read the adapter&#39;s configuration. Fake Adapter Pre-packaged is a fake/static adapter (Geolix.Adapter.Fake) working on a plain Agent holding your IP lookup responses. An example of how you might use this adapter: config :geolix, databases: [ %{ id: :country, adapter: Geolix.Adapter.Fake, data: %{} |&gt; Map.put({1, 1, 1, 1}, %{country: %{iso_code: &quot;US&quot;}}) |&gt; Map.put({2, 2, 2, 2}, %{country: %{iso_code: &quot;GB&quot;}}) } ] Custom Adapters If you need a different database or have other special needs for lookups you can write your own adapter. The only requirement is the usage of the Geolix.Adapter behaviour. As a starting point you can take a close look at the aforementioned Geolix.Adapter.Fake implementation.","ref":"readme.html#adapters","title":"Geolix - Adapters","type":"extras"},{"doc":"Loading Errors If the configuration is erroneous a message will be sent to Logger with the level :error. Any other error during the load process is expected to be defined and logged by the adapter itself. State Retrieval All databases are loaded, unless you called Geolix.load_database/1, asynchronously. This includes configured databases loaded upon application start. The database loader allows you to access the current state of loading: iex(1)&gt; Geolix.Database.Loader.loaded_databases() [:city] iex(2)&gt; Geolix.Database.Loader.registered_databases() [:city, :country] Above example demonstrates a state where the database :country is known but not completely loaded yet. Please be aware that both lists are unsorted. Reloading To trigger a forceful reload of all databases configured in the application environment you can use Geolix.reload_databases/0 to do so. This uses an internal GenServer.cast/2 so a slight delay will occur. Unloading Calling Geolix.unload_database/1 with a database id will unload this database. As this is done in a lazy fashion it will still be kept in memory while not being reloaded or used for lookups. If the database is configured via application environment it will still be reloaded as usual in case of a supervisor or application restart.","ref":"readme.html#database-loading","title":"Geolix - Database Loading","type":"extras"},{"doc":"Lookups are done using Geolix.lookup/1,2: iex(1)&gt; Geolix.lookup(&quot;127.0.0.1&quot;) %{ city: %{...}, country: %{...} } iex(2)&gt; Geolix.lookup({127, 0, 0, 1}, where: :my_database) %{...} Full documentation is available inline in the Geolix module and at https://hexdocs.pm/geolix.","ref":"readme.html#basic-usage","title":"Geolix - Basic Usage","type":"extras"},{"doc":"Apache License, Version 2.0","ref":"readme.html#license","title":"Geolix - License","type":"extras"}]